precision highp float;

varying vec2 v_TexPosition;
varying vec2 v_FragmentPosition;

uniform sampler2D u_TextureOld;
uniform sampler2D u_TextureNew;
uniform float u_MaxRadius;
uniform float u_Progress;
uniform vec2 u_StartPos;

void main() {
	float d = distance(v_FragmentPosition, u_StartPos) / u_MaxRadius;
	vec4 oldColor = texture2D(u_TextureOld, v_TexPosition);
	vec4 newColor = texture2D(u_TextureNew, v_TexPosition);

	if (d <= u_Progress) {
		gl_FragColor = newColor;
	} else {
		gl_FragColor = oldColor;
	}
}