precision highp float;

varying vec2 v_TexPosition;
varying vec2 v_FragmentPosition;

uniform sampler2D u_Pattern;
uniform float u_MaxRadius;
uniform vec4 u_FillColor;
uniform vec2 u_StartPos;
uniform float u_Hardness;
uniform float u_Opacity;
uniform vec2 u_PatternScale;
uniform vec2 u_PatternOffset;
uniform int u_TileFill;

void main() {
	float d = distance(v_FragmentPosition, u_StartPos);
	float a = clamp(d / u_MaxRadius, 0.0, 1.0);

	// pow(0.0, 0.0) results to NaN
	if (u_Hardness > 0.999) {
		a = 1.0;
	} else {
		a = pow(1.0 - a, mix(3.0, 0.0, u_Hardness));
	}

	if (u_TileFill == 1) {
		vec2 patternPosition = v_TexPosition * u_PatternScale + u_PatternOffset;
    	a *= texture2D(u_Pattern, patternPosition).a;
	}

    gl_FragColor = vec4(u_FillColor.rgb * u_Opacity, a * u_Opacity);

}