precision highp float;

uniform sampler2D u_Texture2D;
uniform vec2 u_TexelOffset;

varying float v_WeightArray[3];
varying float v_OffsetArray[2];

varying float v_WeightSum;

varying vec2 v_TextureCoordinate;

void main() {
	vec4 color1 = texture2D(u_Texture2D, v_TextureCoordinate);
    vec4 color2 = texture2D(u_Texture2D, v_TextureCoordinate - u_TexelOffset * v_OffsetArray[1]);
	vec4 color3 = texture2D(u_Texture2D, v_TextureCoordinate - u_TexelOffset * v_OffsetArray[0]);
	vec4 color4 = texture2D(u_Texture2D, v_TextureCoordinate + u_TexelOffset * v_OffsetArray[0]);
	vec4 color5 = texture2D(u_Texture2D, v_TextureCoordinate + u_TexelOffset * v_OffsetArray[1]);

	vec3 sumColor = color1.a * color1.rgb * v_WeightArray[0] +
					color2.a * color2.rgb * v_WeightArray[2] +
					color3.a * color3.rgb * v_WeightArray[1] +
					color4.a * color4.rgb * v_WeightArray[1] +
					color5.a * color5.rgb * v_WeightArray[2];

	float sumAlpha = color1.a * v_WeightArray[0] +
                     color2.a * v_WeightArray[2] +
                     color3.a * v_WeightArray[1] +
                     color4.a * v_WeightArray[1] +
                     color5.a * v_WeightArray[2];

//    sumAlpha /= v_WeightSum;

    gl_FragColor = vec4(sumColor / sumAlpha, sumAlpha / v_WeightSum);
}