#extension GL_OES_standard_derivatives : enable
precision highp float;
uniform float u_Opacity;
uniform float u_RectWidth;
uniform float u_RectHeight;
uniform vec4 u_Color;
varying vec2 v_Position;
void main() {
    float dy = min(u_RectHeight / 2.0 - v_Position.y, u_RectHeight / 2.0 + v_Position.y);
    float dx = min(v_Position.x, 1.0 - v_Position.x) * u_RectWidth;

    float d = min(dx, dy);

    float a = smoothstep(0.0, 2.0, d);
    vec3 rgb;

    a = a * u_Opacity;
	rgb = u_Color.rgb * a;
	gl_FragColor = vec4(rgb, a);
}