precision highp float;

varying vec2 v_TexPosition;
varying vec4 v_Color;
varying float v_Width;
varying float v_Height;
varying vec2 v_Position;

uniform sampler2D u_Texture2D;

void main() {
    float dy = min(v_TexPosition.y, 1.0 - v_TexPosition.y) * v_Height;
    float dx = min(v_TexPosition.x, 1.0 - v_TexPosition.x) * v_Width;

    float d = min(dx, dy);

    float a = smoothstep(0.0, 3.0, d);

    vec4 color = texture2D(u_Texture2D, v_TexPosition);
    float  alpha =  v_Color.a * color.a * a;

    gl_FragColor = vec4(v_Color.rgb, alpha);
}