precision highp float;

uniform mat3 u_Matrix;

attribute vec2 a_Position;
attribute vec2 a_TexPosition;
attribute vec4 a_Color;
attribute float a_Width;
attribute float a_Height;

varying vec4 v_Color;
varying vec2 v_TexPosition;
varying float v_Width;
varying float v_Height;
varying vec2 v_Position;

void main() {
	v_Color = a_Color;
    v_Color.a = clamp(v_Color.a * 255.0 / 254.0, 0.0, 1.0);
    v_Width = a_Width;
    v_Height = a_Height;
    v_Position = a_Position;

	v_TexPosition = a_TexPosition;
	gl_Position = vec4(u_Matrix * vec3(a_Position, 1.0), 1.0);
}