precision highp float;

uniform sampler2D u_SrcTexture;
uniform sampler2D u_DstTexture;
uniform sampler2D u_MaskTexture;

uniform vec2 u_WindowSize;

varying vec2 v_TexPosition;

void main() {
	vec4 srcColor = texture2D(u_SrcTexture, gl_FragCoord.xy / u_WindowSize);
	vec4 dstColor = texture2D(u_DstTexture, gl_FragCoord.xy / u_WindowSize);

	float mask = texture2D(u_MaskTexture, v_TexPosition).a;

    gl_FragColor = mix(srcColor, dstColor, mask);
}